/*
 * Top Level of a Time to digital converter for low-frequency called Crono TDC LF.
 * 
 * This module is the Vivado top-level of the Crono TDC Arty A7.
 * This project is aimed to be used with the Arty A7-35 board.
 * Here, we generate some pulses with the FPGA and introduce them into the the
 * TDC Channels input using **TBD** interface.
 * Arty A7 have exposed this interfaces in it's hihg-speed Pmods: JB & JC.
 * This module uses a crono_tdc for low frequency, using a modeled ISERDESE2 
 * in each input channel.
 *
 * Author: Julian Rodriguez <jnrodriguez@estudiantes.unsam.edu.ar>
 */

module top_level_crono_tdc(i_rx_serial,i_base_clk,o_tx_serial,i_reset,o_led,i_channels_inputs_p,i_channels_inputs_n);
    /* Useful local parameters (just to not use magic numbers). */
    localparam WORKING_TDC_CHANNEL_QTY = 2;  // TDC used channels
    localparam TEST_TDC_CHANNEL_QTY = 1; // there is a channel that could be used to measure some known pattern to test TDC functionality
    localparam TDC_CHANNEL_QTY = WORKING_TDC_CHANNEL_QTY+TEST_TDC_CHANNEL_QTY;

    /* TDC inputs parameters. */
    parameter TDC_CHANNEL_RAM_ADDR_WIDTH = 14;
    parameter TDC_CHANNEL_DATA_REG_WIDTH = 19;
    /* TDC Config registers parameters. */
    parameter CFG_REG_INIT_VAL_TIME_WINDOWS_US = 1000000;
    parameter CFG_REG_INIT_VAL_ENABLED_CHN = {TDC_CHANNEL_QTY{1'b1}}; // all channels are enabled by default
    /* UART parameters. */
    parameter UART_BAUDRATE = 115200;

    /* Useful local parameters (just to not use magic numbers). */
    localparam SYSTEM_CLOCK_FREQUENCY_HZ = 100000000;
    localparam HDLC_LITE_FRAME_MAX_WIDTH_BYTES = 68;
    localparam HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES         = HDLC_LITE_FRAME_MAX_WIDTH_BYTES-4;
    localparam HDLC_LITE_FRAME_DATA_HALF_MAX_WIDTH_BYTES    = HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES/2;

    input i_rx_serial;          // uart RX
    output o_tx_serial;         // uart TX 
    input i_base_clk;           // base clock generated by the fpga
    input i_reset;              // reset signal (active-high)
    output [1:0] o_led;         // leds
    input [WORKING_TDC_CHANNEL_QTY-1:0] i_channels_inputs_p; // positive inputs used to measure signals
    input [WORKING_TDC_CHANNEL_QTY-1:0] i_channels_inputs_n; // negative inputs used to measure signals

    wire clk, clkb, oclk, oclkb;
    
    wire [HDLC_LITE_FRAME_DATA_MAX_WIDTH_BYTES*8-1:0] w_core_logic_rx_data;
    wire [HDLC_LITE_FRAME_DATA_HALF_MAX_WIDTH_BYTES*8-1:0] w_core_logic_tx_data;
    wire w_pattern0_generator_out;

    /* The first channels are used to measure external signals (real inputs) and the
     * last one is connected to a pattern generator. This last one is used to debug and
     * validate that the TDC logic is working correctly. */
    wire [TDC_CHANNEL_QTY-1:0] w_channels_inputs; // array with channels inputs
    wire w_measure_ongoing; // This signal will be high ('1') when TDC is measuring channels

    /* Differential input buffers. */
    genvar i;
    generate
        for(i = 0; i < WORKING_TDC_CHANNEL_QTY; i = i + 1) begin
            IBUFDS IBUFDS_inst (
                .O(w_channels_inputs[i]),   // 1-bit output: Buffer output
                .I(i_channels_inputs_p[i]),  // 1-bit input: Diff_p buffer input (connect directly to top-level port)
                .IB(i_channels_inputs_n[i])  // 1-bit input: Diff_n buffer input (connect directly to top-level port)
            );
        end
    endgenerate
    
    assign w_channels_inputs[WORKING_TDC_CHANNEL_QTY] = w_pattern0_generator_out;

    /* Crono TDC core. */
    crono_tdc_lf #(
        .HDLC_LITE_FRAME_MAX_WIDTH_BYTES(HDLC_LITE_FRAME_MAX_WIDTH_BYTES),
        .TDC_CHANNEL_QTY(TDC_CHANNEL_QTY),
        .TDC_CHANNEL_RAM_ADDR_WIDTH(TDC_CHANNEL_RAM_ADDR_WIDTH),
        .TDC_CHANNEL_DATA_REG_WIDTH(TDC_CHANNEL_DATA_REG_WIDTH),
        .CFG_REG_INIT_VAL_TIME_WINDOWS_US(CFG_REG_INIT_VAL_TIME_WINDOWS_US),
        .CFG_REG_INIT_VAL_ENABLED_CHN(CFG_REG_INIT_VAL_ENABLED_CHN),
        .UART_BAUDRATE(UART_BAUDRATE),
        .SYSTEM_CLOCK_FREQUENCY_HZ(SYSTEM_CLOCK_FREQUENCY_HZ)
    )crono_tdc_lf(
        .i_reset(i_reset),
        .i_clk(clk),
        .i_oclk(oclk),
        .i_clkb(clkb),
        .i_oclkb(oclkb),
        .i_rx_serial(i_rx_serial),
        .o_tx_serial(o_tx_serial),
        .i_channels_inputs(w_channels_inputs),
        .o_measure_ongoing(w_measure_ongoing)
    );

    assign o_led[1] = w_measure_ongoing; // led1 will be turned on when tdc is measuring

    wire w_fast_clock;
    /* Clock generation IP core. */
    clk_wiz_0 clock_gen(
        .o_clk(clk),          // output o_clk
        .o_oclk(oclk),        // output o_oclk
        .o_clkb(clkb),        // output o_clkb
        .o_oclkb(oclkb),      // output o_oclkb
        .o_fast_clk(w_fast_clock), // output fast clock
        .reset(i_reset),    // input reset
        .locked(),
        .i_clk(i_base_clk)  // input clock
    );

    /* Simple led that toggles every DEBUG_LED0_TOGGLE_PERIOD_MS milliseconds. */
    timed_toggler #(
        .TOGGLE_PERIOD_MS(1000),
        .CLOCK_FREQUENCY_HZ(SYSTEM_CLOCK_FREQUENCY_HZ)
    ) debug_led_blinker (
        .i_clk          (clk),
        .i_reset        (i_reset),
        .o_toggle_out   (o_led[0])
    );

    /* Pattern generator used to test Crono TDC functionality. */
    pattern_generator #(
        .PATTERN_SIZE(60),
        .PATTERN(60'b000100100011010001010110011110001001101010111100110111101111)
    ) pattern_generator0 (
        .i_start(w_measure_ongoing),
        .i_clk(w_fast_clock),
        .i_reset(i_reset),
        .o_pattern(w_pattern0_generator_out)
    );


// the "macro" to dump signals
`ifdef COCOTB_SIM
initial begin
  $dumpfile ("top_level_crono_tdc.vcd");
  $dumpvars (0, top_level_crono_tdc);
  #1;
end
`else

    /* ILA instantiation if we are debugging this module with Vivado */
//    `define DEBUG_TOP_LEVEL_CRONO_TDC
    `ifdef DEBUG_TOP_LEVEL_CRONO_TDC
    ila_0 ila_top_level_crono_tdc (
        .clk(w_fast_clock), // input wire clk
        .probe0(w_measure_ongoing),           // 1bit
        .probe1(w_pattern0_generator_out),    // 1bit
        .probe2(clk)                          // 1bit
    );
    `endif

`endif

endmodule
